# std::ctype_byname< wchar_t > Class Template Reference

Inheritance diagram for std::ctype_byname< wchar_t >:

List of all members.

## Detailed Description

### template<>
class std::ctype_byname< wchar_t >

Definition at line 1544 of file locale_facets.h.

## Public Types

- typedef const int * __to_type
- typedef wctype_t __wmask_type
- typedef wchar_t char_type
- typedef unsigned short mask

## Public Member Functions

- ctype_byname (const char *__s, size_t __refs=0)
- const char_type * is (const char_type *__lo, const char_type *__hi, mask *__vec) const
- bool is (mask __m, char_type __c) const
- const char_type * narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
- char narrow (char_type __c, char __dfault) const
- const char_type * scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
- const char_type * scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
- const char_type * tolower (char_type *__lo, const char_type *__hi) const
- char_type tolower (char_type __c) const
- const char_type * toupper (char_type *__lo, const char_type *__hi) const
- char_type toupper (char_type __c) const
- const char * widen (const char *__lo, const char *__hi, char_type *__to) const
- char_type widen (char __c) const

## Static Public Attributes

- static const mask alnum
- static const mask alpha
- static const mask cntrl
- static const mask digit
- static const mask graph
- static locale::id id
- static const mask lower
- static const mask print
- static const mask punct
- static const mask space
- static const mask upper
- static const mask xdigit

## Protected Member Functions

- __wmask_type _M_convert_to_wmask (const mask __m) const
- void _M_initialize_ctype ()
- virtual const char_type * do_is (const char_type *__lo, const char_type *__hi, mask *__vec) const
- virtual bool do_is (mask __m, char_type __c) const
- virtual const char_type * do_narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__dest) const
- virtual char do_narrow (char_type, char __dfault) const
- virtual const char_type * do_scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
- virtual const char_type * do_scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
- virtual const char_type * do_tolower (char_type *__lo, const char_type *__hi) const
- virtual char_type do_tolower (char_type) const
- virtual const char_type * do_toupper (char_type *__lo, const char_type *__hi) const
- virtual char_type do_toupper (char_type) const
- virtual const char * do_widen (const char *__lo, const char *__hi, char_type *__dest) const
- virtual char_type do_widen (char) const

## Static Protected Member Functions

- static __c_locale _S_clone_c_locale (__c_locale &__cloc)
- static void _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
- static void _S_destroy_c_locale (__c_locale &__cloc)
- static __c_locale _S_get_c_locale ()
- static const char * _S_get_c_name ()

## Protected Attributes

- mask _M_bit [16]
- __c_locale _M_c_locale_ctype
- char _M_narrow [128]
- bool _M_narrow_ok
- wint_t _M_widen [1+static_cast< unsigned char >(-1)]
- __wmask_type _M_wmask [16]

## Friends

- class locale::_Impl

## Member Typedef Documentation

typedef wchar_t std::ctype< wchar_t >::char_type `[inherited]`

Typedef for the template parameter wchar_t.

Reimplemented from std::__ctype_abstract_base< wchar_t >.

Definition at line 1225 of file locale_facets.h.

## Member Function Documentation

virtual const char_type* std::ctype< wchar_t >::do_is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec |
| ) |  |  | const`[protected, virtual, inherited]`

Return a mask array.

This function finds the mask for each wchar_t in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the input.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | vec | Pointer to an array of mask storage.

Returns:
  hi.

Implements std::__ctype_abstract_base< wchar_t >.

virtual bool std::ctype< wchar_t >::do_is | ( | mask | __m,
|  | char_type | __c |
| ) |  |  | const`[protected, virtual, inherited]`

Test wchar_t classification.

This function finds a mask M for c and compares it to mask m.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters:

  | c | The wchar_t to find the mask of.
  | m | The mask to compare against.

Returns:
  (M & m) != 0.

Implements std::__ctype_abstract_base< wchar_t >.

virtual const char_type* std::ctype< wchar_t >::do_narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __dest |
| ) |  |  | const`[protected, virtual, inherited]`

Narrow wchar_t array to char array.

This virtual function converts each wchar_t in the range [lo,hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any wchar_t in the input that cannot be converted, dfault is used instead. For an underived ctype<wchar_t> facet, the argument will be copied, casting each element to char.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Implements std::__ctype_abstract_base< wchar_t >.

virtual char std::ctype< wchar_t >::do_narrow | ( | char_type | ,
|  | char | __dfault |
| ) |  |  | const`[protected, virtual, inherited]`

Narrow wchar_t to char.

This virtual function converts the argument to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. For an underived ctype<wchar_t> facet, c will be cast to char and returned.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The wchar_t to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted char.

Implements std::__ctype_abstract_base< wchar_t >.

virtual const char_type* std::ctype< wchar_t >::do_scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[protected, virtual, inherited]`

Find wchar_t matching mask.

This function searches for and returns the first wchar_t c in [lo,hi) for which is(m,c) is true.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a matching wchar_t if found, else hi.

Implements std::__ctype_abstract_base< wchar_t >.

virtual const char_type* std::ctype< wchar_t >::do_scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[protected, virtual, inherited]`

Find wchar_t not matching mask.

This function searches for and returns a pointer to the first wchar_t c of [lo,hi) for which is(m,c) is false.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a non-matching wchar_t if found, else hi.

Implements std::__ctype_abstract_base< wchar_t >.

virtual const char_type* std::ctype< wchar_t >::do_tolower | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[protected, virtual, inherited]`

Convert array to lowercase.

This virtual function converts each wchar_t in the range [lo,hi) to lowercase if possible. Other elements remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Implements std::__ctype_abstract_base< wchar_t >.

virtual char_type std::ctype< wchar_t >::do_tolower | ( | char_type |  | ) | const`[protected, virtual, inherited]`

Convert to lowercase.

This virtual function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | c | The wchar_t to convert.

Returns:
  The lowercase wchar_t if convertible, else c.

Implements std::__ctype_abstract_base< wchar_t >.

virtual const char_type* std::ctype< wchar_t >::do_toupper | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[protected, virtual, inherited]`

Convert array to uppercase.

This virtual function converts each wchar_t in the range [lo,hi) to uppercase if possible. Other elements remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Implements std::__ctype_abstract_base< wchar_t >.

virtual char_type std::ctype< wchar_t >::do_toupper | ( | char_type |  | ) | const`[protected, virtual, inherited]`

Convert to uppercase.

This virtual function converts the wchar_t argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | c | The wchar_t to convert.

Returns:
  The uppercase wchar_t if convertible, else c.

Implements std::__ctype_abstract_base< wchar_t >.

virtual const char* std::ctype< wchar_t >::do_widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __dest |
| ) |  |  | const`[protected, virtual, inherited]`

Widen char array to wchar_t array.

This function converts each char in the input to wchar_t using the simplest reasonable transformation. For an underived ctype<wchar_t> facet, the argument will be copied, casting each element to wchar_t.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Implements std::__ctype_abstract_base< wchar_t >.

virtual char_type std::ctype< wchar_t >::do_widen | ( | char |  | ) | const`[protected, virtual, inherited]`

Widen char to wchar_t.

This virtual function converts the char to wchar_t using the simplest reasonable transformation. For an underived ctype<wchar_t> facet, the argument will be cast to wchar_t.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted wchar_t.

Implements std::__ctype_abstract_base< wchar_t >.

const char_type* std::__ctype_abstract_base< wchar_t >::is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec |
| ) |  |  | const`[inline, inherited]`

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the char array. It does so by returning the value of ctype<char_type>::do_is().

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | vec | Pointer to an array of mask storage.

Returns:
  hi.

Definition at line 185 of file locale_facets.h.

bool std::__ctype_abstract_base< wchar_t >::is | ( | mask | __m,
|  | char_type | __c |
| ) |  |  | const`[inline, inherited]`

Test char_type classification.

This function finds a mask M for c and compares it to mask m. It does so by returning the value of ctype<char_type>::do_is().

Parameters:

  | c | The char_type to compare the mask of.
  | m | The mask to compare against.

Returns:
  (M & m) != 0.

Definition at line 168 of file locale_facets.h.

const char_type* std::__ctype_abstract_base< wchar_t >::narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to |
| ) |  |  | const`[inline, inherited]`

Narrow array to char array.

This function converts each char_type in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char_type in the input that cannot be converted, dfault is used instead. It does so by returning ctype<char_type>::do_narrow(lo, hi, dfault, to).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 352 of file locale_facets.h.

char std::__ctype_abstract_base< wchar_t >::narrow | ( | char_type | __c,
|  | char | __dfault |
| ) |  |  | const`[inline, inherited]`

Narrow char_type to char.

This function converts the char_type to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. It does so by returning ctype<char_type>::do_narrow(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char_type to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted char.

Definition at line 330 of file locale_facets.h.

const char_type* std::__ctype_abstract_base< wchar_t >::scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[inline, inherited]`

Find char_type matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true. It does so by returning ctype<char_type>::do_scan_is().

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to matching char_type if found, else hi.

Definition at line 201 of file locale_facets.h.

const char_type* std::__ctype_abstract_base< wchar_t >::scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[inline, inherited]`

Find char_type not matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is false. It does so by returning ctype<char_type>::do_scan_not().

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  Pointer to non-matching char if found, else hi.

Definition at line 217 of file locale_facets.h.

const char_type* std::__ctype_abstract_base< wchar_t >::tolower | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[inline, inherited]`

Convert array to lowercase.

This function converts each char_type in the range [lo,hi) to lowercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_tolower(lo, hi).

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 275 of file locale_facets.h.

char_type std::__ctype_abstract_base< wchar_t >::tolower | ( | char_type | __c | ) | const`[inline, inherited]`

Convert to lowercase.

This function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_tolower(c).

Parameters:

  | c | The char_type to convert.

Returns:
  The lowercase char_type if convertible, else c.

Definition at line 260 of file locale_facets.h.

const char_type* std::__ctype_abstract_base< wchar_t >::toupper | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[inline, inherited]`

Convert array to uppercase.

This function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_toupper(lo, hi).

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 246 of file locale_facets.h.

char_type std::__ctype_abstract_base< wchar_t >::toupper | ( | char_type | __c | ) | const`[inline, inherited]`

Convert to uppercase.

This function converts the argument to uppercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_toupper().

Parameters:

  | c | The char_type to convert.

Returns:
  The uppercase char_type if convertible, else c.

Definition at line 231 of file locale_facets.h.

const char* std::__ctype_abstract_base< wchar_t >::widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to |
| ) |  |  | const`[inline, inherited]`

Widen array to char_type.

This function converts each char in the input to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 311 of file locale_facets.h.

char_type std::__ctype_abstract_base< wchar_t >::widen | ( | char | __c | ) | const`[inline, inherited]`

Widen char to char_type.

This function converts the char argument to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted char_type.

Definition at line 292 of file locale_facets.h.

## Member Data Documentation

locale::id std::ctype< wchar_t >::id `[static, inherited]`

The facet id for ctype<wchar_t>.

Definition at line 1243 of file locale_facets.h.

The documentation for this class was generated from the following file:

- locale_facets.h